

function Display_Height( )
 {
    return 320;
 }

function Display_Width( )
 {
    return 320;
 }

function MyFrame( duration, data )
 {
  this.m_duration = duration;
  this.m_data = data;
 }

function Element_getByID( id_name )
{
    return document.getElementById( id_name );
}

function Element_Exist( name )
{
    return null != document.getElementById( name );
}

function Player_MakeLayerID( prefix, index )
{
    return prefix + "_layer_" + index;
}

function Player_MakeImageID( prefix, index )
 {
    return prefix + "_image_" + index;
 }

function Layer_Make( image,  prefix, index )
{
    var layer_ID = Player_MakeLayerID( prefix, index );
    var image_ID = Player_MakeImageID( prefix, index );

    /*
<div style="width:100px; height:100px; overflow:hidden;">
 <img src="myimage.jpg" alt="my image">
 </div>
    */
     // <img src='whatever.jpg' style="position:absolute;clip:rect(0, 50px, 50px, 0);overflow:hidden">
    // <img src='whatever.jpg' style="width:46px; height:44px; background:url(img_navsprites.gif) 0 0;" >

    document.write(  "<div id=\"" + layer_ID  + "\"" );
    document.write(  "     style = \"" );
    document.write(  "position:absolute; left: 0px; top: 0px; height: 0px;  width: 0px; " );
    document.write(  "visibility:visible; " );
    document.write(  "overflow:hidden; " );
    document.write(  "z-index:" +  index + "; " );
    document.write(  "\"> " );
    document.write(  "     <img id=\"" + image_ID  + "\" style = \" position:absolute; left: -20px; top: -20px;\" src= \"" + image + "\" > " );
    document.write(  "</div> " );
}

function Player_MakeClip( player, prefix, index, data )
{
    var layer = Element_getByID( Player_MakeLayerID( prefix, index ) );
    var image = Element_getByID( Player_MakeImageID( prefix, index ) );

    layer.style.left   = data[1][0][0]*player.m_TargetWidth;
    layer.style.top    = data[1][0][1]*player.m_TargetHeight;

    layer.style.width  = data[1][1][0]*player.m_TargetWidth;
    layer.style.height = data[1][1][1]*player.m_TargetHeight;

    image.style.left   =  -data[0][0][0]*player.m_SourceWidth * ( player.m_TargetWidth * data[1][1][0])/ ( player.m_SourceWidth * data[0][1][0]);
    image.style.top    =  -data[0][0][1]*player.m_SourceHeight* ( player.m_TargetHeight* data[1][1][1])/ ( player.m_SourceHeight* data[0][1][1]);

    image.style.width   =  player.m_SourceWidth  * ( player.m_TargetWidth * data[1][1][0])/ ( player.m_SourceWidth * data[0][1][0]) ;
    image.style.height  =  player.m_SourceHeight * ( player.m_TargetHeight* data[1][1][1])/ ( player.m_SourceHeight* data[0][1][1]) ;
}

function Play_Frame( player, image, prefix, frame )
 {

    for( var index =0; index < frame.m_data.length; index++ )
    {
        if( false == Element_Exist( Player_MakeLayerID( prefix, index ) ) )
         {
             Layer_Make( image,  prefix, index );
             document.write(  ":D" );
         }
         else
         {
             document.write(  ":)" );
         }

         Player_MakeClip( player, prefix, index, frame.m_data[index] );
    }
 }

function Player_Data(  )
 {
  this.m_image = null;
  this.m_index = null;
  this.m_prefix = null;
  this.m_data =  null;

  this.m_SourceWidth  = 1000;
  this.m_SourceHeight = 1200;
  this.m_TargetWidth  = 512;
  this.m_TargetHeight = 512;
 }

var MyPlayer = new Player_Data();

function Play( image, prefix, data )
{
    MyPlayer.m_image = image;
    MyPlayer.m_index = 0;
    MyPlayer.m_prefix = prefix;
    MyPlayer.m_data =  data;

    x = window.setTimeout( function(){Player_Loop(); }, 10 );
 }

function Player_Loop()
{
    if( MyPlayer.m_data.length <= MyPlayer.m_index )
    {
         return;
    }
     Play_Frame( MyPlayer,  MyPlayer.m_image, MyPlayer.m_prefix, MyPlayer.m_data[MyPlayer.m_index] );
     x = window.setTimeout( function(){Player_Loop();}, MyPlayer.m_data[MyPlayer.m_index].m_duration );
     MyPlayer.m_index++;
 }







